/*
SIGNATURE API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package signaturesapi

import (
	"encoding/json"
)

// checks if the CreateInsignConfigRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateInsignConfigRequest{}

// CreateInsignConfigRequest struct for CreateInsignConfigRequest
type CreateInsignConfigRequest struct {
	Paid *CreateInsignConfigRequestPaid `json:"paid,omitempty"`
	Free *CreateInsignConfigRequestFree `json:"free,omitempty"`
}

// NewCreateInsignConfigRequest instantiates a new CreateInsignConfigRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateInsignConfigRequest() *CreateInsignConfigRequest {
	this := CreateInsignConfigRequest{}
	return &this
}

// NewCreateInsignConfigRequestWithDefaults instantiates a new CreateInsignConfigRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateInsignConfigRequestWithDefaults() *CreateInsignConfigRequest {
	this := CreateInsignConfigRequest{}
	return &this
}

// GetPaid returns the Paid field value if set, zero value otherwise.
func (o *CreateInsignConfigRequest) GetPaid() CreateInsignConfigRequestPaid {
	if o == nil || IsNil(o.Paid) {
		var ret CreateInsignConfigRequestPaid
		return ret
	}
	return *o.Paid
}

// GetPaidOk returns a tuple with the Paid field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateInsignConfigRequest) GetPaidOk() (*CreateInsignConfigRequestPaid, bool) {
	if o == nil || IsNil(o.Paid) {
		return nil, false
	}
	return o.Paid, true
}

// HasPaid returns a boolean if a field has been set.
func (o *CreateInsignConfigRequest) HasPaid() bool {
	if o != nil && !IsNil(o.Paid) {
		return true
	}

	return false
}

// SetPaid gets a reference to the given CreateInsignConfigRequestPaid and assigns it to the Paid field.
func (o *CreateInsignConfigRequest) SetPaid(v CreateInsignConfigRequestPaid) {
	o.Paid = &v
}

// GetFree returns the Free field value if set, zero value otherwise.
func (o *CreateInsignConfigRequest) GetFree() CreateInsignConfigRequestFree {
	if o == nil || IsNil(o.Free) {
		var ret CreateInsignConfigRequestFree
		return ret
	}
	return *o.Free
}

// GetFreeOk returns a tuple with the Free field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateInsignConfigRequest) GetFreeOk() (*CreateInsignConfigRequestFree, bool) {
	if o == nil || IsNil(o.Free) {
		return nil, false
	}
	return o.Free, true
}

// HasFree returns a boolean if a field has been set.
func (o *CreateInsignConfigRequest) HasFree() bool {
	if o != nil && !IsNil(o.Free) {
		return true
	}

	return false
}

// SetFree gets a reference to the given CreateInsignConfigRequestFree and assigns it to the Free field.
func (o *CreateInsignConfigRequest) SetFree(v CreateInsignConfigRequestFree) {
	o.Free = &v
}

func (o CreateInsignConfigRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateInsignConfigRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Paid) {
		toSerialize["paid"] = o.Paid
	}
	if !IsNil(o.Free) {
		toSerialize["free"] = o.Free
	}
	return toSerialize, nil
}

type NullableCreateInsignConfigRequest struct {
	value *CreateInsignConfigRequest
	isSet bool
}

func (v NullableCreateInsignConfigRequest) Get() *CreateInsignConfigRequest {
	return v.value
}

func (v *NullableCreateInsignConfigRequest) Set(val *CreateInsignConfigRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateInsignConfigRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateInsignConfigRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateInsignConfigRequest(val *CreateInsignConfigRequest) *NullableCreateInsignConfigRequest {
	return &NullableCreateInsignConfigRequest{value: val, isSet: true}
}

func (v NullableCreateInsignConfigRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateInsignConfigRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


